#include "stdafx.h"
#include <stdlib.h>
#include "MemMan.h"
#include "Mem.h"
#include "MemManagerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CMemManagerDlg* pDlg;
CProc* pCurrentProc = NULL;
INT    nLoadingProc = 0,
       nDelProcID   = 0,
       nNextProc    = 0,
       nLoadProc    = 0,
       nCurrentProc = 0;
INT   uFreeMem, uTime = 0;

CPtrArray ProcArray, SegmTablesArray;

UINT   READ_TIME, WRITE_TIME, ALLOC_TIME, FREE_TIME, SWAP_TIME, LOAD_TIME, 
       CREATE_TIME, KILL_TIME, SELECT_TIME, DEATTACH_TIME, KVANT_TIME;

CProc::CProc(INT id)
{
    uID = id;
    uDemTime    = rand() % pDlg->m_uMaxTimeOfProc;
    uCodeSize   = rand() % pDlg->m_uMaxSegm;
    uDataSize   = rand() % pDlg->m_uMaxSegm;
    uStackSize  = rand() % (pDlg->m_uMaxSegm/8);
    nLastOper   = -1;
    uWorkTime = 0;
}

VOID CProc::ExecProc(VOID)
{
    WORD      wRand, wTemp;

    if( nLastOper != -1 ) wTemp = nLastOper;
    else wTemp = rand() % 4; 

    switch( wTemp )
    {
        case 0 :
            if( nLastOper == -1 ) 
            {
                uTemp1 = rand() % pDlg->m_uMaxSegm;
            }

            MAlloc ( this,  uTemp1);
            uWorkTime += ALLOC_TIME;
            uTime     += ALLOC_TIME;
            break;

        case 1 :
            if( nLastOper == -1 ) 
            {
                if(this->bup.uNumSegm == 3) { ExecProc(); return; }
                uTemp1 = rand() % this->bup.uNumSegm;
                if(uTemp1 < 3) uTemp1 = 3;
            }
            MFree ( this,  uTemp1 );
            uWorkTime += FREE_TIME;
            uTime     += FREE_TIME;
            break;

        case 2 :
            if( nLastOper == -1 ) 
            {
                uTemp1 = rand() % this->bup.uNumSegm;
                //PSEGMTABLESTRING psts = ((PSEGMTABLESTRING)(*(bup.pSegmTable))[uTemp1]);
                wRand  = ( ((PSEGMTABLESTRING)(*(bup.pSegmTable))[uTemp1])->uSegmSize)*1024;
                if(!wRand) uTemp2 = 0;
                else uTemp2 = rand() % (wRand+80);
            }
            
            //DEBUGMSG( "Exec: process %i, segm = %i, offset = %i, maxoffset = %i", uID, uTemp1, uTemp2, ((PSEGMTABLESTRING)(*(bup.pSegmTable))[uTemp1])->uSegmSize*1024 );
            
            MRead ( this, uTemp1, uTemp2 ); 
            uWorkTime += READ_TIME;
            uTime     += READ_TIME;
            break;

        case 3 :
            if( nLastOper == -1 ) 
            {
                uTemp1 = rand() % this->bup.uNumSegm;
                wRand  = ( ((PSEGMTABLESTRING)(*(bup.pSegmTable))[uTemp1])->uSegmSize)*1024;
                if(!wRand) uTemp2 = 0;
                else uTemp2 = rand() % (wRand+80);
            }
            
            //DEBUGMSG( "Exec: process %i, segm = %i, offset = %i, maxoffset = %i", uID, uTemp1, uTemp2, ((PSEGMTABLESTRING)(*(bup.pSegmTable))[uTemp1])->uSegmSize*1024 );
            MWrite ( this, uTemp1, uTemp2 );
            uWorkTime += WRITE_TIME;
            uTime     += WRITE_TIME;
            break;
    }
}

VOID CreateProc   ( )
{
    CProc *proc = new CProc(++nLoadProc);
    ++nLoadingProc;
    CString csTemp;
 
    csTemp.Format( "Create      :      %i%s", proc->uID, "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);
    
    CPtrArray* pSegmTable = new CPtrArray;
    proc->bup.pSegmTable    = pSegmTable;
    proc->bup.uFlag         = 0;
    proc->bup.uNumSegm      = 0;

    MAlloc   ( proc, proc->uCodeSize,  TRUE  );
    LoadSegm ( proc, 0, ",  "   );
    MAlloc   ( proc, proc->uDataSize,  TRUE  );
    LoadSegm ( proc, 1, ",  " );
    MAlloc   ( proc, proc->uStackSize, TRUE );
    LoadSegm ( proc, 2, ",  "  );

    ProcArray.Add( (PVOID) proc );

    csTemp.Format( "Create       :  %i     %s", proc->uID, "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);

    uTime     += CREATE_TIME;
}

VOID Kill     ( )
{
    CString csTemp;

    pCurrentProc->bup.pSegmTable->RemoveAll();

    ProcArray.RemoveAt(nCurrentProc/*pCurrentProc->uID-1*/);
    nLoadingProc --;

    csTemp.Format( "Kill            :  %i     %s", pCurrentProc->uID, "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);

    csTemp.Format( "MFree      :       %i%s", pCurrentProc->uID, "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);

    delete pCurrentProc->bup.pSegmTable;

    csTemp.Format( "Kill            :     %i%s", pCurrentProc->uID, "\r\n" );
    pDlg->m_csOutput += csTemp;
    csTemp.Format( "Kill            :  %i     %s", pCurrentProc->uID, "\r\n" );
    pDlg->m_csOutput += csTemp;
    csTemp.Format( "Kill            :  %i  %s", pCurrentProc->uID, "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);

    uTime     += KILL_TIME;

    delete pCurrentProc;
}

VOID Select   ( )
{
    CString csTemp;
    if(nLoadingProc <= nNextProc) nNextProc = nLoadingProc-1;
    nCurrentProc = nNextProc;
    pCurrentProc = (CProc*) ProcArray[nNextProc];

    csTemp.Format( "Select       :  %i   %s", pCurrentProc->uID, "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);

    if( nNextProc == nLoadingProc-1 ) nNextProc = 0;
    else nNextProc++;

    uTime     += SELECT_TIME;
}

VOID Execute  ( )
{
    CString csTemp;
    UINT    uBeginWork;
    uBeginWork = pCurrentProc->uWorkTime;

    csTemp.Format( "Execute    :  %i  ,  %i%s", pCurrentProc->uID, uTime, "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);

    while( ((pCurrentProc->uWorkTime - uBeginWork) <  KVANT_TIME) && !nDelProcID &&
           pCurrentProc->uWorkTime < pCurrentProc->uDemTime ) 
    {
        pCurrentProc->ExecProc();
    }
    
    if( nDelProcID )  { Kill    (); nDelProcID = 0; }
    else if( pCurrentProc->uWorkTime >= pCurrentProc->uDemTime )
    {
        DEBUGMSG("OK");
        csTemp.Format( "Execute    :  %i  ,  %i%s", pCurrentProc->uID, uTime, "\r\n" );
        pDlg->m_csOutput += csTemp;
        pDlg->UpdateData(FALSE);
        Kill();
    }
    else
    {
        csTemp.Format( "Execute    :  %i    ,  %i%s", pCurrentProc->uID, uTime, "\r\n" );
        pDlg->m_csOutput += csTemp;
        pDlg->UpdateData(FALSE);
        Deattach();
    }
}

VOID Deattach ( )
{
    CString csTemp;

    csTemp.Format( "Deattach  :  %i   %s", pCurrentProc->uID, "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);
 
    uTime     += DEATTACH_TIME;
}

VOID INT_AdrErr  ( CProc * proc, PSTR szErr )
{
    CString csTemp;
    
    csTemp.Format( "INT_AdrErr :  %i,      %s%s", proc->uID, szErr, "\r\n" );
    pDlg->m_csOutput += csTemp;
    csTemp.Format( "INT_AdrErr :  %i     %s", proc->uID, "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);

    nDelProcID = proc->uID;

    Deattach();
}

VOID INT_SegmErr ( CProc * proc, UINT uSegm )
{
    CString csTemp;

    csTemp.Format( "INT_SegmErr :  %i    %i,   %s", proc->uID, uSegm, "\r\n" );
    pDlg->m_csOutput += csTemp;

    Deattach();
    nNextProc = proc->uID - 1;

    LoadSegm( proc, uSegm );
    nNextProc = nCurrentProc;

    Select();
    
    csTemp.Format( "Execute     :  %i  %s", proc->uID, "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);

    proc->ExecProc();
}

VOID MAlloc ( CProc * proc, UINT uSize, BOOL bCreate )
{
    UINT uLastAdress = 0;
    INT  i, j;
    CString csTemp;

    if( !bCreate )
    {
        csTemp.Format( "Execute    :  %i     %s", proc->uID, "\r\n" );
        pDlg->m_csOutput += csTemp;
    
        Deattach();
        nNextProc = nCurrentProc;
        //if( nNextProc == 0 ) nNextProc = nLoadingProc;
        //else nNextProc--;
    }

    if( uFreeMem < uSize )
    {
//        DEBUGMSG("OK");
        csTemp.Format( "MAlloc      :     %s", "\r\n" );
        pDlg->m_csOutput += csTemp;
        pDlg->UpdateData(FALSE);
        for(i = 0; (i < ProcArray.GetSize()) && (uFreeMem < uSize); i++)
        {
            for(j = ((CProc*)ProcArray[i])->bup.pSegmTable->GetSize()-1; (j >= 0) && (uFreeMem < uSize); j--)
            {
                SwapSegm ( (CProc*)ProcArray[i], j );
            }
        }
    }

    PSEGMTABLESTRING psts = new SEGMTABLESTRING;
    psts->uSegmSize = uSize;
    psts->cFlagInMem  = 1;
    psts->cFlagCreate = 1;

    if(bCreate && SegmTablesArray.GetSize() < (INT)nLoadingProc) 
    {
        CPtrArray* pa = new CPtrArray;
        SegmTablesArray.Add( (PVOID) pa );
        proc->bup.pSegmTable = pa;
    }

    proc->bup.pSegmTable->Add( (PVOID) psts );
    proc->bup.uNumSegm++;
    uFreeMem -= uSize;

    csTemp.Format( "MAlloc      :    %i   %i,  %i%s", proc->bup.uNumSegm-1, proc->uID, uSize, "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);
    
    if( !bCreate ) Select();
}

VOID MFree ( CProc * proc, UINT uSegm )
{
    CString csTemp;

    if( uSegm > proc->bup.pSegmTable->GetSize()-1 )
    {  
        csTemp.Format( " - 1     %i", uSegm );
        INT_AdrErr  ( proc, (PSTR)(LPCTSTR)csTemp );
        return;
    }

    if ( !(((PSEGMTABLESTRING)(*(proc->bup.pSegmTable))[uSegm]))->cFlagCreate )
    {  
        csTemp.Format( " - 2     %i", uSegm );
        INT_AdrErr  ( proc, (PSTR)(LPCTSTR)csTemp );
        return;
    }

    csTemp.Format( "Execute    :  %i   %i,    %s", proc->uID, uSegm, "\r\n" );
    pDlg->m_csOutput += csTemp;
    
    Deattach();
    nNextProc = nCurrentProc;

    ((PSEGMTABLESTRING)((*(proc->bup.pSegmTable))[uSegm]))->cFlagInMem  = 0;
    ((PSEGMTABLESTRING)((*(proc->bup.pSegmTable))[uSegm]))->cFlagCreate = 0;
    uFreeMem += ((PSEGMTABLESTRING)((*(proc->bup.pSegmTable))[uSegm]))->uSegmSize;
    proc->bup.uNumSegm--;

    csTemp.Format( "MFree       : C %i  %i   %s", uSegm, proc->uID,  "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);

    Select();
}

VOID LoadSegm ( CProc * proc, UINT uSegm, PSTR szAddText )
{
    CString csTemp;

    if( uSegm > proc->bup.pSegmTable->GetSize()-1 )
    {  
        DEBUGMSG ( "LoadSegm -  " );
        return;
    }
    
    ((PSEGMTABLESTRING)(*(proc->bup.pSegmTable))[uSegm])->cFlagInMem = 1;

    csTemp.Format( "LoadSegm:   %i   %i%s%s", uSegm, proc->uID, szAddText, "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);

    uTime     += LOAD_TIME;
}

VOID SwapSegm ( CProc * proc, UINT uSegm )
{
    CString csTemp;

    if( uSegm > proc->bup.pSegmTable->GetSize()-1 )
    {  
        DEBUGMSG ( "SwapSegm -  " );
        return;
    }

    ((PSEGMTABLESTRING)(*(proc->bup.pSegmTable))[uSegm])->cFlagInMem = 0;
    uFreeMem += ((PSEGMTABLESTRING)(*(proc->bup.pSegmTable))[uSegm])->uSegmSize;
    csTemp.Format( "SwapSegm    :   %i  %i  %s", uSegm, proc->uID, "\r\n" );
    pDlg->m_csOutput += csTemp;
    pDlg->UpdateData(FALSE);

    uTime     += SWAP_TIME;
}

VOID MRead  ( CProc * proc, UINT uSegm, UINT uOffset )
{
    CString csTemp;

    if( proc->bup.pSegmTable->GetSize() > uSegm)
    {
        if( ((PSEGMTABLESTRING)(*(proc->bup.pSegmTable))[uSegm])->cFlagCreate )
        {
            if( ((PSEGMTABLESTRING)(*(proc->bup.pSegmTable))[uSegm])->cFlagInMem )
            {
                if( ((PSEGMTABLESTRING)(*(proc->bup.pSegmTable))[uSegm])->uSegmSize*1024 >= uOffset)
                {
                    csTemp.Format( "MRead     :  %i, :  %i  %i%s", proc->uID, uSegm, uOffset, "\r\n" );
                    pDlg->m_csOutput += csTemp;
                    pDlg->UpdateData(FALSE);
                }
                else
                {
//                    DEBUGMSG( "MRead, process %i, segm %i, offset %i", proc->uID, uSegm, uOffset );
                    INT_AdrErr  ( proc, " -  ,    " );
                    return;
                }
            }
            else
            {
                DEBUGMSG("OK2");
                proc->nLastOper = 2;
                INT_SegmErr ( proc, uSegm );
                return;
            }
        }
        else
        {
            INT_AdrErr  ( proc, " -    " );
            return;
        }
    }
    else
    {
        INT_AdrErr  ( proc, " -    " );
        return;
    }
    
    proc->nLastOper = -1;
}

VOID MWrite  ( CProc * proc, UINT uSegm, UINT uOffset )
{
    CString csTemp;

    if( proc->bup.pSegmTable->GetSize() > uSegm)
    {
        if( ((PSEGMTABLESTRING)(*(proc->bup.pSegmTable))[uSegm])->cFlagCreate )
        {
            if( ((PSEGMTABLESTRING)(*(proc->bup.pSegmTable))[uSegm])->cFlagInMem )
            {
                if( ((PSEGMTABLESTRING)(*(proc->bup.pSegmTable))[uSegm])->uSegmSize*1024 >= uOffset)
                {
                    csTemp.Format( "MWrite     :  %i, :  %i  %i%s", proc->uID, uSegm, uOffset, "\r\n" );
                    pDlg->m_csOutput += csTemp;
                    pDlg->UpdateData(FALSE);
                }
                else
                {
//                    DEBUGMSG( "MWrite, process %i, segm %i, offset %i", proc->uID, uSegm, uOffset );
                    INT_AdrErr  ( proc, " -  ,    " );
                    return;
                }
            }
            else
            {
                proc->nLastOper = 3;
                INT_SegmErr ( proc, uSegm );
                DEBUGMSG("OK2");
                return;
            }
        }
        else
        {
            INT_AdrErr  ( proc, " -    " );
            return;
        }
    }
    else
    {
        INT_AdrErr  ( proc, " -    " );
        return;
    }

    proc->nLastOper = -1;
}

VOID DEBUGMSG (PSTR szFormat, ... )
{
#ifdef _DEBUG   
    PSTR szBuffer = new char[2*MAX_PATH];
    PSTR pArguments;

    pArguments = (PSTR) &szFormat + sizeof(szFormat);
    vsprintf(szBuffer, szFormat, pArguments);

    MessageBox(NULL, szBuffer, "DEBUG MESSAGE", MB_OK);
    delete szBuffer;
#endif
}
